package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.PanelWrapper _testpanel = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scrollview1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="TestPanel.Initialize(\"\")";
mostCurrent._testpanel.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="Activity.AddView(TestPanel,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._testpanel.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="TestPanel.LoadLayout(\"TestPage\")";
mostCurrent._testpanel.LoadLayout("TestPage",mostCurrent.activityBA);
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="TestPanel.Visible=True";
mostCurrent._testpanel.setVisible(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
RDebugUtils.currentModule="main";
com.jamesmurty.utils.XMLBuilder _x = null;
anywheresoftware.b4a.objects.PanelWrapper _pnl = null;
int _i = 0;
anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _chk = null;
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Button1_Click";
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Dim x As XMLBuilder";
_x = new com.jamesmurty.utils.XMLBuilder();
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="x = x.create(\"wasp\")";
_x = _x.create("wasp");
RDebugUtils.currentLine=327685;
 //BA.debugLineNum = 327685;BA.debugLine="x = x.element(\"sample_no\") _ 		.attribute(\"id\",\"123456\") _ 			.element(\"samp_details\") _ 				.element(\"project_code\") _ 					.text(\"GBRI5\") _ 				.up() _ 				.element(\"samp_type\") _ 					.text(\"IS\") _ 				.up() _ 				.element(\"containers\") _ 					.text(\"3\") _ 				.up() _ 				.element(\"date_sampled\") _ 					.text(\"01/01/1901\") _ 				.up() _ 				.element(\"sampler\") _ 					.text(\"ORRD\") _ 				.up() _ 				.element(\"collect_auth\") _ 					.text(\"DH\") _ 				.up() _ 				.element(\"sample_source\") _ 					.text(\"SS\") _ 				.up() _ 				.element(\"qa_type\") _ 					.text(\"BLANK\") _ 				.up() _ 				.element(\"site_no\") _ 					.text(\"136001A\") _ 				.up() _ 				.element(\"sw_time\") _ 					.text(\"10:33\") _ 				.up() _ 				.element(\"sw_height\") _ 					.text(\"999.99\") _ 				.up() _ 				.element(\"sw_depth\") _ 					.text(\"999.99\") _ 				.up() _ 				.element(\"sw_disch\") _ 					.text(\"\") _ 				.up() _ 				.element(\"sw_sampdist\") _ 					.text(\"\") _ 				.up() _ 				.element(\"swwidth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwrn\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwpipe\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwrec\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwsampdepth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwtotaldepth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwpumptime\") _ 					.text(\"\") _ 				.up() _ 				.element(\"notes\") _ 					.text(\"This is a note.\") _ 				.up() _ 			.up() _ 			.element(\"bottle_details\") _ 				.element(\"bottle_details1\") _ 					.element(\"bottle_type\") _ 						.text(\"A\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details2\") _ 					.element(\"bottle_type\") _ 						.text(\"D\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"FR\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details3\") _ 					.element(\"bottle_type\") _ 						.text(\"E\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"FR\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details4\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details5\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details6\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details7\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 			.up() _ 			.element(\"test_details\") _ 				.element(\"test_details1\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details2\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details3\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details4\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details5\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details6\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details7\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 			.up() _ 			.element(\"field_results\") _ 				.element(\"conduct\") _ 					.text(\"222\") _ 				.up() _ 				.element(\"water_temp\") _ 					.text(\"22\") _ 				.up() _ 				.element(\"ph\") _ 					.text(\"7\") _ 				.up() _ 				.element(\"do2\") _ 					.text(\"\") _ 				.up() _ 				.element(\"turb\") _ 					.text(\"\") _ 				.up() _ 				.element(\"air_temp\") _ 					.text(\"\") _ 				.up() _ 				.element(\"total_alk\") _ 					.text(\"\") _ 				.up() _ 			.up() _ 		.up() _ 	.up()";
_x = _x.element("sample_no").attribute("id","123456").element("samp_details").element("project_code").text("GBRI5").up().element("samp_type").text("IS").up().element("containers").text("3").up().element("date_sampled").text("01/01/1901").up().element("sampler").text("ORRD").up().element("collect_auth").text("DH").up().element("sample_source").text("SS").up().element("qa_type").text("BLANK").up().element("site_no").text("136001A").up().element("sw_time").text("10:33").up().element("sw_height").text("999.99").up().element("sw_depth").text("999.99").up().element("sw_disch").text("").up().element("sw_sampdist").text("").up().element("swwidth").text("").up().element("gwrn").text("").up().element("gwpipe").text("").up().element("gwrec").text("").up().element("gwsampdepth").text("").up().element("gwtotaldepth").text("").up().element("gwpumptime").text("").up().element("notes").text("This is a note.").up().up().element("bottle_details").element("bottle_details1").element("bottle_type").text("A").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details2").element("bottle_type").text("D").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("FR").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details3").element("bottle_type").text("E").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("FR").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details4").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details5").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details6").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details7").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().up().element("test_details").element("test_details1").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details2").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details3").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details4").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details5").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details6").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details7").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().up().element("field_results").element("conduct").text("222").up().element("water_temp").text("22").up().element("ph").text("7").up().element("do2").text("").up().element("turb").text("").up().element("air_temp").text("").up().element("total_alk").text("").up().up().up().up();
RDebugUtils.currentLine=327981;
 //BA.debugLineNum = 327981;BA.debugLine="File.WriteString(File.DirInternal, \"Test1.xml\", x.asString)";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"Test1.xml",_x.asString());
RDebugUtils.currentLine=327983;
 //BA.debugLineNum = 327983;BA.debugLine="Msgbox(File.ReadString(File.DirInternal,\"Test1.xml\"),\"Test1\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"Test1.xml"),"Test1",mostCurrent.activityBA);
RDebugUtils.currentLine=327987;
 //BA.debugLineNum = 327987;BA.debugLine="x=x.parse(File.OpenInput(File.DirInternal,\"Test1.xml\"))";
_x = _x.parse((org.xml.sax.InputSource)(anywheresoftware.b4a.keywords.Common.File.OpenInput(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"Test1.xml").getObject()));
RDebugUtils.currentLine=327989;
 //BA.debugLineNum = 327989;BA.debugLine="x = x.element(\"sample_no\") _ 		.attribute(\"id\",\"123456\") _ 			.element(\"samp_details\") _ 				.element(\"project_code\") _ 					.text(\"GBRI5\") _ 				.up() _ 				.element(\"samp_type\") _ 					.text(\"IS\") _ 				.up() _ 				.element(\"containers\") _ 					.text(\"3\") _ 				.up() _ 				.element(\"date_sampled\") _ 					.text(\"01/01/1901\") _ 				.up() _ 				.element(\"sampler\") _ 					.text(\"ORRD\") _ 				.up() _ 				.element(\"collect_auth\") _ 					.text(\"DH\") _ 				.up() _ 				.element(\"sample_source\") _ 					.text(\"SS\") _ 				.up() _ 				.element(\"qa_type\") _ 					.text(\"BLANK\") _ 				.up() _ 				.element(\"site_no\") _ 					.text(\"136001A\") _ 				.up() _ 				.element(\"sw_time\") _ 					.text(\"10:33\") _ 				.up() _ 				.element(\"sw_height\") _ 					.text(\"999.99\") _ 				.up() _ 				.element(\"sw_depth\") _ 					.text(\"999.99\") _ 				.up() _ 				.element(\"sw_disch\") _ 					.text(\"\") _ 				.up() _ 				.element(\"sw_sampdist\") _ 					.text(\"\") _ 				.up() _ 				.element(\"swwidth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwrn\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwpipe\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwrec\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwsampdepth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwtotaldepth\") _ 					.text(\"\") _ 				.up() _ 				.element(\"gwpumptime\") _ 					.text(\"\") _ 				.up() _ 				.element(\"notes\") _ 					.text(\"This is a note.\") _ 				.up() _ 			.up() _ 			.element(\"bottle_details\") _ 				.element(\"bottle_details1\") _ 					.element(\"bottle_type\") _ 						.text(\"A\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details2\") _ 					.element(\"bottle_type\") _ 						.text(\"D\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"FR\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details3\") _ 					.element(\"bottle_type\") _ 						.text(\"E\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"FSS\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"MA\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"FR\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details4\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details5\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details6\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 				.element(\"bottle_details7\") _ 					.element(\"bottle_type\") _ 						.text(\"\") _ 					.up() _ 					.element(\"bott_lab_code\") _  						.text(\"\") _ 					.up() _ 					.element(\"collect_meth\") _ 						.text(\"\") _ 					.up() _ 					.element(\"preserv_meth1\") _ 						.text(\"CH\") _ 					.up() _ 					.element(\"preserv_meth2\") _ 						.text(\"DA\") _ 					.up() _ 					.element(\"preserv_meth3\") _ 						.text(\"\") _ 					.up() _ 				.up() _ 			.up() _ 			.element(\"test_details\") _ 				.element(\"test_details1\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details2\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details3\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details4\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details5\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details6\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 				.element(\"test_details7\") _ 					.element(\"test_code\") _ 						.text(\"SEQEM1\") _ 					.up() _ 					.element(\"test_lab_code\") _ 						.text(\"FSS\") _ 					.up() _ 				.up _ 			.up() _ 			.element(\"field_results\") _ 				.element(\"conduct\") _ 					.text(\"222\") _ 				.up() _ 				.element(\"water_temp\") _ 					.text(\"22\") _ 				.up() _ 				.element(\"ph\") _ 					.text(\"7\") _ 				.up() _ 				.element(\"do2\") _ 					.text(\"\") _ 				.up() _ 				.element(\"turb\") _ 					.text(\"\") _ 				.up() _ 				.element(\"air_temp\") _ 					.text(\"\") _ 				.up() _ 				.element(\"total_alk\") _ 					.text(\"\") _ 				.up() _ 			.up() _ 		.up() _ 	.up()";
_x = _x.element("sample_no").attribute("id","123456").element("samp_details").element("project_code").text("GBRI5").up().element("samp_type").text("IS").up().element("containers").text("3").up().element("date_sampled").text("01/01/1901").up().element("sampler").text("ORRD").up().element("collect_auth").text("DH").up().element("sample_source").text("SS").up().element("qa_type").text("BLANK").up().element("site_no").text("136001A").up().element("sw_time").text("10:33").up().element("sw_height").text("999.99").up().element("sw_depth").text("999.99").up().element("sw_disch").text("").up().element("sw_sampdist").text("").up().element("swwidth").text("").up().element("gwrn").text("").up().element("gwpipe").text("").up().element("gwrec").text("").up().element("gwsampdepth").text("").up().element("gwtotaldepth").text("").up().element("gwpumptime").text("").up().element("notes").text("This is a note.").up().up().element("bottle_details").element("bottle_details1").element("bottle_type").text("A").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details2").element("bottle_type").text("D").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("FR").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details3").element("bottle_type").text("E").up().element("bott_lab_code").text("FSS").up().element("collect_meth").text("MA").up().element("preserv_meth1").text("FR").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details4").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details5").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details6").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().element("bottle_details7").element("bottle_type").text("").up().element("bott_lab_code").text("").up().element("collect_meth").text("").up().element("preserv_meth1").text("CH").up().element("preserv_meth2").text("DA").up().element("preserv_meth3").text("").up().up().up().element("test_details").element("test_details1").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details2").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details3").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details4").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details5").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details6").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().element("test_details7").element("test_code").text("SEQEM1").up().element("test_lab_code").text("FSS").up().up().up().element("field_results").element("conduct").text("222").up().element("water_temp").text("22").up().element("ph").text("7").up().element("do2").text("").up().element("turb").text("").up().element("air_temp").text("").up().element("total_alk").text("").up().up().up().up();
RDebugUtils.currentLine=328285;
 //BA.debugLineNum = 328285;BA.debugLine="File.WriteString(File.DirInternal, \"Test2.xml\", x.asString)";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"Test2.xml",_x.asString());
RDebugUtils.currentLine=328287;
 //BA.debugLineNum = 328287;BA.debugLine="Msgbox(File.ReadString(File.DirInternal,\"Test2.xml\"),\"Test2\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"Test2.xml"),"Test2",mostCurrent.activityBA);
RDebugUtils.currentLine=328289;
 //BA.debugLineNum = 328289;BA.debugLine="Dim Pnl As Panel";
_pnl = new anywheresoftware.b4a.objects.PanelWrapper();
RDebugUtils.currentLine=328291;
 //BA.debugLineNum = 328291;BA.debugLine="Pnl = ScrollView1.Panel";
_pnl = mostCurrent._scrollview1.getPanel();
RDebugUtils.currentLine=328293;
 //BA.debugLineNum = 328293;BA.debugLine="For i = 1 To 10";
{
final int step29 = 1;
final int limit29 = (int) (10);
for (_i = (int) (1); (step29 > 0 && _i <= limit29) || (step29 < 0 && _i >= limit29); _i = ((int)(0 + _i + step29))) {
RDebugUtils.currentLine=328294;
 //BA.debugLineNum = 328294;BA.debugLine="Dim Chk As CheckBox";
_chk = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
RDebugUtils.currentLine=328295;
 //BA.debugLineNum = 328295;BA.debugLine="Chk.Initialize(\"\")";
_chk.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=328296;
 //BA.debugLineNum = 328296;BA.debugLine="Chk.Text = \"Item # \" & i";
_chk.setText((Object)("Item # "+BA.NumberToString(_i)));
RDebugUtils.currentLine=328297;
 //BA.debugLineNum = 328297;BA.debugLine="Dim Lbl As Label";
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();
RDebugUtils.currentLine=328298;
 //BA.debugLineNum = 328298;BA.debugLine="Lbl.Initialize(\"\")";
_lbl.Initialize(mostCurrent.activityBA,"");
RDebugUtils.currentLine=328299;
 //BA.debugLineNum = 328299;BA.debugLine="Lbl.Text = \"Value # \" & i";
_lbl.setText((Object)("Value # "+BA.NumberToString(_i)));
RDebugUtils.currentLine=328300;
 //BA.debugLineNum = 328300;BA.debugLine="Pnl.AddView(Chk,0,5%y * (i-1),20%x,5%y)";
_pnl.AddView((android.view.View)(_chk.getObject()),(int) (0),(int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5),mostCurrent.activityBA)*(_i-1)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (20),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5),mostCurrent.activityBA));
RDebugUtils.currentLine=328301;
 //BA.debugLineNum = 328301;BA.debugLine="Pnl.AddView(Lbl,20%x,5%y * (i-1),20%x,5%y)";
_pnl.AddView((android.view.View)(_lbl.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (20),mostCurrent.activityBA),(int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5),mostCurrent.activityBA)*(_i-1)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (20),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5),mostCurrent.activityBA));
 }
};
RDebugUtils.currentLine=328304;
 //BA.debugLineNum = 328304;BA.debugLine="End Sub";
return "";
}
public static String  _test_scroll() throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub Test_Scroll";
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="End Sub";
return "";
}
}